#include <wx/event.h>
#include <wx/list.h>

class wxCurlDownloadThread;
class wxCurlEndPerformEvent;
class FileInformation;

WX_DECLARE_LIST(FileInformation, DownloadQueue);

class DownloadManager : public wxEvtHandler
{
public:
	wxCurlDownloadThread *downloadThread; // TODO: one per server?
	DownloadQueue *downloadQueue;
	FileInformation *currentDownload;

	DownloadManager();
	~DownloadManager();

	void add( FileInformation *fileInfo );
	void startNextDownload();
	void onDownloadComplete( wxCurlEndPerformEvent &event );

	DECLARE_EVENT_TABLE();
};
